#include once "windows.bi"
#include once "win/commctrl.bi"
#include once "win/ole2.bi"
#include once "webctrl.bi"
const WIN_BROWSER = WEBCTRL_IE 		'' or WEBCTRL_MOZILLA

#include once "fbdoc_loader.bi"
#include once "fbdoc_loader_web.bi"
#include once "fbdoc_string.bi"
#include once "fbdoc_keywords.bi"
#include once "CWiki.bi"
#include once "CWikiCon.bi"
#include once "list.bi"
#include once "fbdoc_loader.bi"

#include once "resource.bi"

#include once "mkwiki.bi"

'' Globals
dim shared as HWND ghwndMain = NULL

declare function WndProc ( byval hWnd as HWND, _
                   byval message as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT

declare function DefWndProc ( byval hWnd as HWND, _
                   byval message as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT


using fb
using fbdoc

extern as CWikiCon ptr wikicon 

' %%% extern as string sUserName
' %%% extern as string sPassword

dim shared sCurrPage as string

dim shared as webctrl ptr browser = NULL

'' --------------------------------------------------------------------------
'' MAIN WINDOW FUNCTIONS
'' --------------------------------------------------------------------------

'':::::
function GetPage _
	( _
		byref sPage as string, _
		byref sBody as string _
	) as integer

	print "Loading..."; sPage; ": ";
	
	'' sBody = LoadPage( sPage, FALSE, TRUE )

	if( wikicon->LoadPage( sPage, TRUE, TRUE, sBody ) = FALSE ) then
		print "ERROR"
		browser->navigate( "about:blank" )
	else
		print "OK"
		SavePage( sPage, sBody )
		HtmlPreview_Generate( sPage )
		browser->navigate( "file://" + curdir + "/html/" + sPage + ".html" )
	end if

	return( sBody > "" )

end function

'':::::
function PutPage _
	( _
		byref sPage as string, _
		byref sBody as string, _
		byref sNote as string _
	) as integer

	dim sBodyOld as string

	function = FALSE

	if( Connection_Login( ghwndMain ) = FALSE ) then
		print "Unable to login"
		exit function
	end if

	if( wikicon->LoadPage( sPage, TRUE, TRUE, sBodyOld ) <> FALSE ) then
		if( wikicon->GetPageID() > 0 ) then
			' %%% if( wikicon->Login( sUserName, sPassword ) ) = FALSE then
			' %%%	print "Unable to login"
			' %%% else
				print "Storing '" + sPage + "' [" + sNote + "] : ";

				if( wikicon->StorePage( sBody, sNote ) = FALSE ) then
					print "FAILED"
				else
					print "OK"
					function = TRUE
				end if
			' %%% end if
		else
			print "Unable to get existing page ID - will try to store as a new page .."
			' %%% if( wikicon->Login( sUserName, sPassword ) ) = FALSE then
			' %%% 	print "Unable to login"
			' %%% else
				print "Storing '" + sPage + "': ";
				if( wikicon->StoreNewPage( sBody, sPage ) = FALSE ) then
					print "FAILED"
				else
					print "OK"
					function = TRUE
				end if
			' %%% end if
		end if
	else
		print "Unable to get existing page"
	end if

end function

'':::::
private sub _load_pagenames_list(byval ctl as HWND)
	dim as string x

	static inhere as integer = FALSE

	if( inhere ) then
		exit sub
	end if

	inhere = TRUE

	if ( ctl ) then

		print "Loading Page Names ... "; 

		SendMessage(ctl, LB_RESETCONTENT, 0, 0)

		dim h as integer
		h = FreeFile
		if( open( "PageIndex.txt" for input as #h ) = 0 ) then
			while eof(h) = 0
				line input #h, x
				if x > "" then
					SendMessage(ctl, LB_ADDSTRING, 0, cast(LPARAM,strptr(x)))
				end if
			wend
			close #h

			print "OK"

		else

			print "ERROR"

		end if

	end if

	inhere = FALSE

end sub

'':::::
public sub MainRefreshIndex()
	RefreshPageIndex( FALSE )
	_load_pagenames_list( GetDlgItem( ghwndMain, IDC_MAINWIN_LIST ))	
end sub

'':::::
function CopyToClipboard(byref x as string) as integer
	function = false
	dim as HANDLE hText = NULL
	dim as ubyte ptr clipmem = NULL
	dim as integer n = len(x)
	if n > 0 then
		hText = GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, n + 1)
		sleep 15
		if (hText) then
			clipmem = GlobalLock(hText)
			if clipmem then
				CopyMemory(clipmem, strptr(x), n)
			else
				hText = NULL
			end if
			if GlobalUnlock(hText) then
				hText = NULL
			end if
		end if
		if (hText) then
			if OpenClipboard(NULL) then
				sleep 15
				if EmptyClipboard() then
					sleep 15
					if SetClipboardData(CF_TEXT, hText) then
						sleep 15
						function = True
					end if
				end if
				CloseClipboard()
			end if
		end if
	end if
end function

'':::::
function SpellCheck_OnClick() as integer

#ifdef HAVE_ASPELL

	dim as HWND ctl

	ctl = GetDlgItem( ghwndMain, IDC_MAINWIN_EDIT )

	return SpellCheck( ctl )

#else
	return FALSE
#endif
	
end function

'':::::
function Preview_OnClick() as integer

	dim as HWND ctl
	dim as string sBody
	dim as integer textlen

	static inhere as integer

	function = FALSE

	if inhere = TRUE then
		exit function
	end if
	inhere = TRUE

	if( sCurrPage > "" ) then

		ctl = GetDlgItem( ghwndMain, IDC_MAINWIN_EDIT )
		textlen = getWindowTextLength(ctl)

		if( textlen > 0 ) then
			sBody = space( textlen ) 
			SendMessage( ctl, WM_GETTEXT, textlen + 1, cast( LPARAM, strptr( sBody ) ) )

			'' Store the page in the cache
			SavePage( sCurrPage, sBody )
			
			HtmlPreview_Generate( sCurrPage )
			browser->navigate( "file://" + curdir + "/html/" + sCurrPage + ".html" )

			function = TRUE

		end if

	end if

	inhere = FALSE

end function

'':::::
sub Post_OnClick( byval hwnd as HWND )
	dim as HWND ctl
	dim as string sBody
	dim as integer textlen
	dim as string sNote

	static inhere as integer

	if inhere = TRUE then
		exit sub
	end if

	inhere = TRUE

	sNote = "Formatting"

	ctl = GetDlgItem( ghwndMain, IDC_MAINWIN_NOTE )
    textlen = getWindowTextLength(ctl)

	if( textlen > 0 ) then
		sNote = space( textlen ) 
		SendMessage( ctl, WM_GETTEXT, textlen + 1, cast( LPARAM, strptr( sNote ) ) )
	end if

	ctl = GetDlgItem( ghwndMain, IDC_MAINWIN_EDIT )
    textlen = getWindowTextLength(ctl)

	if( textlen > 0 ) then
		sBody = space( textlen ) 
		SendMessage( ctl, WM_GETTEXT, textlen + 1, cast( LPARAM, strptr( sBody ) ) )

		PutPage( sCurrPage, sBody, sNote )

	end if

	inhere = FALSE
	
end sub

'':::::
private sub SetPageLink(byval id as integer, byval sPageName as zstring ptr)
	dim as HWND ctl
	ctl = GetDlgItem(ghwndMain, IDC_MAINWIN_LIST2)
	if (ctl) then
		if (id = 0) then
			SendMessage(ctl, LB_RESETCONTENT, 0, 0)
		else 
			if( sPageName ) then
				if( len(*sPageName) > 0 ) then
					if SendMessage(ctl, LB_FINDSTRING, cast(WPARAM, -1), cast(LPARAM,sPageName)) = LB_ERR then
						SendMessage(ctl, LB_ADDSTRING, 0, cast(LPARAM,sPageName))
					end if
				end if
			end if
		end if
	end if
end sub

'':::::
private sub _LoadPage(byref sPage as string, byref sBody as String)

	''dim as string sPath
	redim  as string a(1 to 1)
	dim as integer n, i
	dim as CList ptr lst
	dim as WikiPageLink ptr pagelink

	sBody = ""

	if( GetPage( sPage, sBody ) ) then
	
		sCurrPage = sPage

		'' Handle CRLF conversion for output
		sBody = ReplaceSubStr(sBody, chr(10), chr(13,10))

		dim as CWiki ptr wiki
		wiki = new CWiki()
		if wiki then
			wiki->Parse( strptr(sPage), strptr(sBody) ) 

			SetPageLink 0, NULL

			lst = wiki->GetDocTocLinks(FALSE)

			pagelink = lst->GetHead()
			do while( pagelink <> NULL )
				SetPageLink 1, pagelink->link.url
				pagelink = lst->GetNext( pagelink )
			loop

			delete wiki
		else
			? "Unable to CWiki_New(  )"
		end if

	end if

end sub

'':::::
sub List_OnClick(byval idc as DWORD)

	dim as HWND	ctl 
	dim as integer i, size
	dim as string sPage, sBody

	static inHere as integer = FALSE

	if( inHere ) then
		exit sub
	end if

	inHere = TRUE
	
	ctl = GetDlgItem(ghwndMain, idc)
	if ( ctl ) then
    i = SendMessage(ctl, LB_GETCURSEL, 0, 0)
		if i >= 0 then
			size = SendMessage(ctl, LB_GETTEXTLEN, i, 0)
			sPage = space(size)
			if ( size > 0 ) then
				SendMessage(ctl, LB_GETTEXT, i, cast(LPARAM, strptr(sPage)))
			end if
		end if
	end if

	if sPage > "" then
		if sPage <> sCurrPage then
			_LoadPage sPage, sBody
			ctl = GetDlgItem(ghwndMain, IDC_MAINWIN_EDIT)
			SendMessage(ctl, WM_SETTEXT, 0, cast(LPARAM, strptr(sBody)))
			ctl = GetDlgItem(ghwndMain, IDC_MAINWIN_NAME)
			SendMessage(ctl, WM_SETTEXT, 0, cast(LPARAM, strptr(sPage)))
		end if
	end if

	inHere = FALSE

end sub

'':::::
sub Copy_OnClick()
	dim sText as string
	dim as HWND ctl
	dim as integer size
	ctl = GetDlgItem(ghwndMain, IDC_MAINWIN_EDIT)
	if ( ctl ) then
    size = getWindowTextLength(ctl)
		sText = space(size)
		if ( size > 0 ) then
			SendMessage(ctl, WM_GETTEXT, size + 1, cast(LPARAM, strptr(sText)))
		end if
	end if
	
	CopyToClipboard(sText)
end sub

'':::::
function Edit_GetSelText() as string
	dim as HWND ctl
	dim as integer size
	dim as string sText
	function = ""
	ctl = GetDlgItem(ghwndMain, IDC_MAINWIN_EDIT)
	if ( ctl ) then
    size = getWindowTextLength(ctl)
		if size > 0 then
			dim as integer s1, s2
			Sendmessage(ctl, EM_GETSEL, cast(WPARAM, @s1), cast(LPARAM, @s2))
			if s2 - s1 > 0 and s2 <= size then
				sText = space(size)
				if ( size > 0 ) then
					SendMessage(ctl, WM_GETTEXT, size + 1, cast(LPARAM, strptr(sText)))
				end if
				function = mid(sText, s1 + 1, s2 - s1)
			end if
		end if
	end if
end function

'':::::
sub Edit_SetSelText(byref sText as string)
	dim as HWND ctl
	ctl = GetDlgItem(ghwndMain, IDC_MAINWIN_EDIT)
	if ( ctl ) then
		SendMessage(ctl, EM_REPLACESEL, TRUE, cast(LPARAM, strptr(sText))) 
	end if
end sub

'':::::
function Link_OnClick() as integer
	dim as string s, sPage, sDesc, sLink, sText, a, b, t
	dim as integer i

	Link_OnClick = False

	s = Edit_GetSelText()
	if len(s) > 0 then
		t = Trim(s, any chr(9,10,13,32))
		if len(t) > 0 then
			i = instr(s, t)
			if i > 0 then
				a = left(s, i - 1)
				b = mid(s, i + len(t))
				sDesc = t
/'
				'' !!! FIX ME !!! - need title.txt from 'fbdoc -maketitles' to do this
				if LookUpKeywordPageByName(sPage, sDesc, sLink) then
					if( lcase( left( sPage, 5)) = "keypg" ) then
						if( left( sDesc, 1 ) = "_" ) then
							sText = a & "##[[" & sPage & " " & ucase(sLink) & "]]##" & b
						else
							sText = a & "##[[" & sPage & " " & FormatPageTitle(sLink) & "]]##" & b
						end if
					else
						sText = a & "##[[" & sPage & " " & sLink & "]]##" & b
					end if
					Edit_SetSelText sText
					Link_OnClick = True
				end if
'/					
			end if
		end if
	end if
end function

'' --------------------------------------------------------------------------
'' MAIN WINDOW CREATION / STARTUP
'' --------------------------------------------------------------------------

'':::::
function init_controls(byval hInstance as HINSTANCE, byval hwnd as HWND) as integer

	dim as HWND hwndctrl
	dim as DWORD bstyle = WS_VISIBLE or WS_CHILD or BS_PUSHBUTTON
	dim as DWORD xstyle = 0 ''WS_EX_CLIENTEDGE 

	function = FALSE

	hwndctrl = CreateWindowEx( xstyle, "BUTTON", "Copy", bStyle,   0, 0, 64, 22, hwnd, cast(HMENU, IDC_MAINWIN_COPY), hInstance, NULL)
	SendMessage(hwndctrl, WM_SETFONT, Cast(WPARAM, GetStockObject(ANSI_FIXED_FONT)), FALSE)
	hwndctrl = CreateWindowEx( xstyle, "BUTTON", "Post", bStyle,  64, 0, 64, 22, hwnd, cast(HMENU, IDC_MAINWIN_POST), hInstance, NULL)
	SendMessage(hwndctrl, WM_SETFONT, Cast(WPARAM, GetStockObject(ANSI_FIXED_FONT)), FALSE)
	hwndctrl = CreateWindowEx( xstyle, "STATIC", "<<No Page>>", bStyle, 192, 0, 192, 22, hwnd, cast(HMENU, IDC_MAINWIN_NAME), hInstance, NULL)
	SendMessage(hwndctrl, WM_SETFONT, Cast(WPARAM, GetStockObject(ANSI_FIXED_FONT)), FALSE)

	hwndctrl = CreateWindowEx( xstyle, "BUTTON", "Preview", bStyle, 384, 0, 64, 22, hwnd, cast(HMENU, IDC_MAINWIN_PREVIEW), hInstance, NULL)
	SendMessage(hwndctrl, WM_SETFONT, Cast(WPARAM, GetStockObject(ANSI_FIXED_FONT)), FALSE)

	hwndctrl = CreateWindowEx( xstyle, "EDIT", "", _
		WS_VISIBLE or WS_CHILD OR WS_BORDER or ES_AUTOHSCROLL _
			, 480, 0, 162, 22, hwnd, cast(HMENU, IDC_MAINWIN_NOTE), hInstance, NULL)
	SendMessage(hwndctrl, WM_SETFONT, Cast(WPARAM, GetStockObject(ANSI_FIXED_FONT)), FALSE)

	xstyle = WS_EX_CLIENTEDGE
	hwndctrl = CreateWindowEx( xstyle, "LISTBOX", NULL, _
		WS_VISIBLE or WS_CHILD or WS_VSCROLL or LBS_HASSTRINGS or LBS_NOTIFY or LBS_SORT, _
								0, 23, 192, 400, hwnd, cast(HMENU, IDC_MAINWIN_LIST), hInstance, NULL)
	SendMessage(hwndctrl, WM_SETFONT, Cast(WPARAM, GetStockObject(ANSI_FIXED_FONT)), FALSE)

	xstyle = WS_EX_CLIENTEDGE
	hwndctrl = CreateWindowEx( xstyle, "LISTBOX", NULL, _
		WS_VISIBLE or WS_CHILD or WS_VSCROLL or LBS_HASSTRINGS or LBS_NOTIFY or LBS_SORT, _
								0, 23, 192, 400, hwnd, cast(HMENU, IDC_MAINWIN_LIST2), hInstance, NULL)
	SendMessage(hwndctrl, WM_SETFONT, Cast(WPARAM, GetStockObject(ANSI_FIXED_FONT)), FALSE)

	xstyle = WS_EX_CLIENTEDGE
	hwndctrl = CreateWindowEx( xstyle, "EDIT", NULL, _
		WS_VISIBLE or WS_CHILD or ES_MULTILINE or ES_WANTRETURN or WS_VSCROLL, _
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
		hwnd, cast(HMENU, IDC_MAINWIN_EDIT), hInstance, NULL)
	SendMessage(hwndctrl, WM_SETFONT, Cast(WPARAM, GetStockObject(ANSI_FIXED_FONT)), FALSE)



	dim as WNDCLASSEX wc
	dim as zstring ptr className = @"mkwiki_preview"

	with wc
		.cbSize 		= len( WNDCLASSEX )
		.lpfnWndProc 	= @DefWndProc
		.hInstance 		= hInstance
		.lpszClassName 	= className
		'.style			= CS_HREDRAW or CS_VREDRAW
	end with
	RegisterClassEx( @wc )

	xstyle = 0
	hwndctrl = CreateWindowEx( xstyle, className, NULL, _
		WS_VISIBLE or WS_CHILDWINDOW, _
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
		hwnd, cast(HMENU, IDC_MAINWIN_BROWSER), hInstance, NULL)

	browser = new webctrl( hwndctrl, _
						   0, _
						   0, _
						   400, _
						   400, _
						   WIN_BROWSER )

	function = TRUE

end function

'' --------------------------------------------------------------------------
'' MAIN WINDOW PROC
'' --------------------------------------------------------------------------

function DefWndProc ( byval hWnd as HWND, _
                   byval message as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT
    function = DefWindowProc( hWnd, message, wParam, lParam )    
	
end function

'':::::
function WndProc ( byval hWnd as HWND, _
                   byval message as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT
    
		dim as integer nWidth, nHeight, wmId, wmEvent
		dim rct as RECT, rctl as RECT
		dim pnt as PAINTSTRUCT
		dim hDC as HDC

		function = 0

		select case ( message )
		case WM_CREATE
			init_controls GetModuleHandle(NULL), hwnd
			if( browser ) then
				browser->navigate( "about:blank" )
			end if
			exit function

		case WM_COMMAND
			wmId    = loword( wParam )
			wmEvent = hiword( wParam )
			select case wmId
			case IDC_MAINWIN_COPY
				Copy_OnClick()
				exit function
			case IDC_MAINWIN_POST
				Post_OnClick( hwnd )
				exit function
			case IDC_MAINWIN_EXIT, ID_FILE_EXIT
				PostMessage( ghwndMain, WM_CLOSE, 0, 0 )
				exit function
			case ID_TOOLS_REFRESHPAGEINDEX
				RefreshPageIndex( TRUE )
				_load_pagenames_list( GetDlgItem( ghwndMain, IDC_MAINWIN_LIST ))	
				exit function
			case IDC_MAINWIN_LIST, IDC_MAINWIN_LIST2
				List_OnClick(wmId)
				exit function
			'case IDC_MAINWIN_LINK, ID_ACCEL_LINK
			'	if Link_OnClick() then
			'		exit function
			'	end if
			case IDC_MAINWIN_PREVIEW, ID_ACCEL_PREVIEW, ID_TOOLS_REFRESHPREVIEW
				if Preview_OnClick() then
					exit function
				end if

			case ID_ACCEL_SPELLCHECK, ID_TOOLS_SPELLCHECK
				if SpellCheck_OnClick() then
					exit function
				end if

			end select

		case WM_SIZE
			dim as integer h1, h2

			nWidth = LOWORD(lParam)
			nHeight = HIWORD(lParam)

			h1 = (nHeight - 23) * 0.5
			h2 = (nHeight - 23) - h1
			if h1 > 0 and h2 > 0 then
				MoveWindow(GetDlgItem(ghwndMain, IDC_MAINWIN_EDIT), 192, 23 + h1, nWidth - 192, h2, TRUE)
				MoveWindow(GetDlgItem(ghwndMain, IDC_MAINWIN_BROWSER), 192, 23, nWidth - 192, h1, TRUE)
				browser->move( 0, 0, nWidth - 192, h2 )
			end if

			h1 = (nHeight - 23) * 3 \ 4
			h2 = (nHeight - 23) - h1
			if h1 > 0 and h2 > 0 then
				MoveWindow(GetDlgItem(ghwndMain, IDC_MAINWIN_LIST), 0, 23, 192, h1 , TRUE)
				MoveWindow(GetDlgItem(ghwndMain, IDC_MAINWIN_LIST2), 0, 23 + h1, 192, h2, TRUE)
			end if
			exit function
        
		case WM_CLOSE
			DestroyWindow(ghwndMain)
			PostQuitMessage( 0 )
			exit function

		case WM_DESTROY
			if( browser ) then
				delete browser
				browser = NULL
			end if
			PostQuitMessage( 0 )
			exit function

    end select
    
    function = DefWindowProc( hWnd, message, wParam, lParam )    
    
end function

'':::::
public function Create_Main_Window _
	( _
		byval hInstance as HINSTANCE, _
		byval AppName as zstring ptr, _
		byval AppTitle as zstring ptr _
	) as HWND

	dim wcls as WNDCLASS     
	dim hWnd as HWND

	'' Setup window class
	with wcls
		.style         = CS_HREDRAW or CS_VREDRAW
		.lpfnWndProc   = @WndProc
		.cbClsExtra    = 0
		.cbWndExtra    = 0
		.hInstance     = hInstance
		.hIcon         = NULL ' LoadIcon( null, IDI_APPLICATION )
		.hCursor       = LoadCursor( null, IDC_ARROW )
		.hbrBackground = cast(HBRUSH, COLOR_BTNFACE + 1) '' GetStockObject(  )
		.lpszMenuName  = cast(zstring ptr, IDR_MAIN_MENU)
		.lpszClassName = cast(LPCTSTR, AppName )
	end with
 
	'' Register the window class     
	if ( RegisterClass( @wcls ) = false ) then
		MessageBox( null, "Could not register the window class", AppTitle, MB_ICONERROR )
		return NULL
	end if

	'' Create the window and show it
	hWnd = CreateWindowEx(WS_EX_CONTROLPARENT, _
		AppName, _
		AppTitle, _
		WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN, _
		CW_USEDEFAULT, _
		CW_USEDEFAULT, _
		CW_USEDEFAULT, _
		CW_USEDEFAULT, _
		null, _
		null, _
		hInstance, _
		null )

	ghwndMain = hWnd

	return hWnd

end function
